VERSION 5.00
Object = "{A6978A84-C40F-11D5-ADA7-009027BF5C2D}#1.0#0"; "x-coolbr.ocx"
Begin VB.Form frmCoolbars 
   AutoRedraw      =   -1  'True
   BackColor       =   &H8000000C&
   Caption         =   "Coolbars!"
   ClientHeight    =   6945
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   5175
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   Icon            =   "WIN CoolBar Create.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6945
   ScaleWidth      =   5175
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstInfo 
      Enabled         =   0   'False
      Height          =   1425
      Left            =   240
      TabIndex        =   5
      Top             =   2280
      Width           =   4095
   End
   Begin CoolBars.ReBar ReBar 
      Height          =   750
      Left            =   0
      TabIndex        =   2
      Top             =   600
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   1323
   End
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "WIN CoolBar Create.frx":0BC2
      MousePointer    =   99  'Custom
      Picture         =   "WIN CoolBar Create.frx":1004
      ScaleHeight     =   615
      ScaleWidth      =   5175
      TabIndex        =   4
      Top             =   0
      Width           =   5175
   End
   Begin VB.PictureBox picImages 
      Height          =   300
      Left            =   0
      Picture         =   "WIN CoolBar Create.frx":202D
      ScaleHeight     =   240
      ScaleWidth      =   16800
      TabIndex        =   3
      Top             =   1800
      Visible         =   0   'False
      Width           =   16860
   End
   Begin CoolBars.MenuBar MenuBar 
      Height          =   285
      Left            =   120
      Top             =   4080
      Width           =   3120
      _ExtentX        =   5477
      _ExtentY        =   503
      Wrappable       =   0   'False
   End
   Begin CoolBars.ToolBar ToolBar 
      Height          =   525
      Left            =   120
      Top             =   4680
      Width           =   9255
      _ExtentX        =   16298
      _ExtentY        =   926
      ButtonWidth     =   54
      ButtonHeight    =   35
      ShowDropArrows  =   0   'False
      SmartResize     =   -1  'True
      Wrappable       =   0   'False
   End
   Begin VB.PictureBox picIcon 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   4080
      Picture         =   "WIN CoolBar Create.frx":6A6F
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   1
      Top             =   1440
      Width           =   255
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   0
      Text            =   "Combo1"
      Top             =   1440
      Visible         =   0   'False
      Width           =   3855
   End
End
Attribute VB_Name = "frmCoolbars"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Coolbar Windows
'
' 6 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' Compiler Directives


#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

#Const DISP_COMBO = False
#Const DISP_ICON = True
#Const USE_HOOKS = True


'------------------------------------------------------------------
' Picture

Private Pic As IPicture

'------------------------------------------------------------------
' Menu Items

Private Const MENU_FILE = 1
Private Const MENU_EDIT = 2
Private Const MENU_VIEW = 3
Private Const MENU_WINDOW = 4
Private Const MENU_HELP = 5


Private Const MENU_ICON_MASK = &HFFFF00
Private Const MENU_DEFAULT_FLAGS = 0 Or PopupMenus.mnuFlagDrawnByOwner


'------------------------------------------------------------------
' Make Popup Menus

Private mnuPopup(MENU_FILE To MENU_HELP) As PopupMenus.MenuContainer



'------------------------------------------------------------------
' Initialize

Private Sub Form_Load()
  Dim mnuSubItem As PopupMenus.MenuContainer
  Dim IML As ImageListCore.ImageList
  Dim I As Long
  
  DoEvents
  
  ' Create the imagelist.
  Set IML = ImageListCreate(, , imlColor16 Or imlCreateMask)
  IML.Images.Add picImages.Picture, MENU_ICON_MASK ' Add the picture strip
  IML.BackColor = MenuBar.BackColor                ' The replacement for the transparent color
  
  ' Make the menus
  Set mnuPopup(MENU_FILE) = PopupMenus.CreateSubMenu()
  Set mnuPopup(MENU_FILE).DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
  With mnuPopup(MENU_FILE).Menus
    .Add , "New"
'    .Add(, "&New" & vbTab & "Ctrl+N", vbCtrlMask, vbKeyN, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 2
    .Add(, "&Open" & vbTab & "Ctrl+O", vbCtrlMask, vbKeyO, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 20
    .Add(, "&Close", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "&Save" & vbTab & "Ctrl+S", vbCtrlMask, vbKeyS, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 1
    .Add(, "Save &As...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "Save A&ll", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "Propert&ies", , , MENU_DEFAULT_FLAGS, PopupMenus.mnuStateGrayed).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 4
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "&Print..." & vbTab & "Ctrl+P", vbCtrlMask, vbKeyP, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 23
    .Add(, "Print Set&up...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "Print Pre&view", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 36
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "Sen&d...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 24
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "E&xit", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
  End With
  
  Set mnuPopup(MENU_EDIT) = PopupMenus.CreateSubMenu()
  Set mnuPopup(MENU_EDIT).DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
  With mnuPopup(MENU_EDIT).Menus
    .Add(, "&Undo" & vbTab & "Ctrl+Z", vbCtrlMask, vbKeyZ, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 5
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "Cu&t" & vbTab & "Ctrl+X", vbCtrlMask, vbKeyX, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 6
    .Add(, "&Copy" & vbTab & "Ctrl+C", vbCtrlMask, vbKeyC, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 7
    .Add(, "&Paste" & vbTab & "Ctrl+V", vbCtrlMask, vbKeyV, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 8
    .Add(, "Paste &Special...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 38
    .Add(, "&Delete" & vbTab & "Del", , vbKeyDelete, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 3
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "Select &All" & vbTab & "Ctrl+A", vbCtrlMask, vbKeyA, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "&Invert Selection", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
  End With
  
  Set mnuPopup(MENU_VIEW) = PopupMenus.CreateSubMenu()
  Set mnuPopup(MENU_VIEW).DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
  With mnuPopup(MENU_VIEW).Menus
    .Add(, "&Toolbar", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "Status &Bar", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "Lar&ge Icons", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 15
    .Add(, "S&mall Icons", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 16
    .Add(, "&List", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 17
    .Add(, "&Details", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 18
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    Set mnuSubItem = PopupMenus.CreateSubMenu()
    Set mnuSubItem.DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
    With mnuSubItem.Menus
      .Add(, "by &Name", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
      .Add(, "by &Type", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
      .Add(, "by Si&ze", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
      .Add(, "by &Date", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    End With
    .Add(, "Arrange &Icons", , , MENU_DEFAULT_FLAGS, , , , , mnuSubItem).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "Li&ne Up Icons", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 44
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "&Refresh", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 19
    .Add(, "&Options...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
  End With
  
  Set mnuPopup(MENU_WINDOW) = PopupMenus.CreateSubMenu()
  Set mnuPopup(MENU_WINDOW).DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
  With mnuPopup(MENU_WINDOW).Menus
    .Add(, "&New Window", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add(, "&Cascade", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 63
    .Add(, "Tile &Horizontal", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 64
    .Add(, "Tile &Vertical", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 65
    .Add(, "&Arrange Icons", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 66
  End With
  
  Set mnuPopup(MENU_HELP) = PopupMenus.CreateSubMenu()
  Set mnuPopup(MENU_HELP).DrawExtras.ImageLists(PopupMenus.mnuImageNormal) = IML
  With mnuPopup(MENU_HELP).Menus
    .Add(, "&Help", , vbKeyF1, MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 48
    .Add(, "&Contents", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 30
    .Add(, "&Search For Help On...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
    .Add , , , , PopupMenus.mnuFlagSeparator Or MENU_DEFAULT_FLAGS
    .Add(, "&About CoolBar Sample...", , , MENU_DEFAULT_FLAGS).DrawExtras.IconIndex(PopupMenus.mnuImageNormal) = 0
  End With
  
  
#If DISP_COMBO Then
  ' Init combobox
  Me.Combo1.AddItem "Combo1 - Item1"
  Me.Combo1.AddItem "Combo1 - Item2"
  Me.Combo1.AddItem "Combo1 - Item3"
  Me.Combo1.ListIndex = 0
#End If
  
  ' Init rebar
  If Len(Dir("C:\iebar.bmp")) <> 0 Then
    Set Pic = LoadPicture("C:\iebar.bmp")
  Else
    Set Pic = LoadPicture()
  End If
  With Me.MenuBar
    .Menus.Add , "NEW", "&File", , mnuPopup(MENU_FILE)
    .Menus.Add , "EDIT", "&Edit", , mnuPopup(MENU_EDIT)
    .Menus.Add , "VIEW", "&View", , mnuPopup(MENU_VIEW)
    .Menus.Add , "WINDOW", "&Window", , mnuPopup(MENU_WINDOW)
    .Menus.Add , "HELP", "&Help", , mnuPopup(MENU_HELP)
  End With
  
  ' Init Toolbar
  With Me.ToolBar
    Dim StartPos As Long
    ' Captions are invisible because .TextRows = 0
    StartPos = .LoadButtonImageList(tbrIconStandardSmallColor)
    .Buttons.Add , "NEW", "New", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileNew, , "Create a new document"
    .Buttons.Add , "OPEN", "Open", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileOpen, , "Open an existing document"
    .Buttons.Add , "SAVE", "Save", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileSave, , "Save the current document"
    .Buttons.Add , , , tbrStyleSeparator
    .Buttons.Add , "PRINT", "Print", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconPrint, , "Send the document to the printer"
    .Buttons.Add , "PREVIEW", "Preview", tbrStyleAutoSize, tbrStateChecked Or tbrStateEnabled, StartPos + TbrImageListsStandardIcons.tbrIconPrintPreview, , "Preview the printer result"
    .Buttons.Add , , , tbrStyleSeparator
    .Buttons.Add , "CUT", "Cut", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconCut, , "Move the selected text to the windows clipboard"
    .Buttons.Add , "COPY", "Copy", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconCopy, , "Copy the selected text to the windows clipboard"
    .Buttons.Add , "PASTE", "Paste", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconPaste, , "Insert text from the windows clipboard"
    .Buttons.Add , "DELETE", "Delete", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconDelete, , "Delete the selected text"
    .Buttons.Add , , , tbrStyleSeparator
    .Buttons.Add , "UNDO", "Undo", tbrStyleAutoSize Or tbrStyleDropDown, 0, StartPos + TbrImageListsStandardIcons.tbrIconUndo, , "Undo the most recent change"
    .Buttons.Add , "REDO", "Redo", tbrStyleAutoSize Or tbrStyleDropDown, 0, StartPos + TbrImageListsStandardIcons.tbrIconRedo, , "Redo the most recent change"
    .Buttons.Add , , , tbrStyleSeparator
    .Buttons.Add , "FIND", "Find", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFind, , "Find text"
    .Buttons.Add , "REPLACE", "Replace", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconReplace, , "Replace text"
    .Buttons.Add , , , tbrStyleSeparator
    .Buttons.Add , "PROPERTIES", "Properties", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconProperties, , "Properties"
    .Buttons.Add , "HELP", "Help", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconHelp, , "Help"
  End With
  
  ' Add rebar bands
  #If (WIN32_IE >= IE4) Then
    Me.ReBar.Bands.Add , "MENUBAR", , 165 Or rbrDisplayChevron, Pic, MenuBar.hWnd
    Me.ReBar.Bands.Add , "TOOLBAR", , 165 Or rbrDisplayChevron, Pic, Me.ToolBar.hWnd
    #If DISP_COMBO Then
      Me.ReBar.Bands.Add , "COMBOBOX", , 165 Or rbrHideWhenVertical, Pic, Me.Combo1.hWnd
    #End If
    #If DISP_ICON Then
      Me.ReBar.Bands.Add , "ICON", , (rbrFixedSize Or rbrGripperNever), , Me.picIcon.hWnd, Me.picIcon.ScaleWidth, Me.picIcon.ScaleWidth, Me.picIcon.ScaleHeight
    #End If
  #Else
    Me.ReBar.Bands.Add , "MENUBAR", , 37, Pic, MenuBar.hWnd
    Me.ReBar.Bands.Add , "TOOLBAR", , 37, Pic, Me.ToolBar.hWnd
    #If DISP_COMBO Then
      Me.ReBar.Bands.Add , "COMBOBOX", , 165 Or rbrHideWhenVertical, Pic, Me.Combo1.hWnd
    #End If
    #If DISP_ICON Then
      Me.ReBar.Bands.Add , "ICON", , (rbrFixedSize), , Me.picIcon.hWnd, Me.picIcon.ScaleWidth, Me.picIcon.ScaleWidth, Me.picIcon.ScaleHeight
    #End If
  #End If
  
  Me.ReBar.Bands(2).BackColor = vbBlack
  
  
  ' Init text
  Me.lstInfo.AddItem ""
  Me.lstInfo.AddItem "Coolbar Sample"
  Me.lstInfo.AddItem "- Toolbars, menus and bands are created on the fly"
  Me.lstInfo.AddItem "- Imagelist used for menu icons"
  Me.lstInfo.AddItem "- Costomizing is not supported yet"
End Sub


'------------------------------------------------------------------
' Resize controls

Private Sub Form_Resize()
  If Me.ReBar.Orientation = rbrHorizontal Then
    Me.ReBar.Width = Me.ScaleWidth
  Else
    Me.ReBar.Height = Me.ScaleHeight
  End If
  
  Dim TopPos As Long
  TopPos = ReBar.Top + ReBar.Height
  Call Me.lstInfo.Move(0, TopPos, Me.ScaleWidth, Me.ScaleHeight - TopPos)
End Sub


' ==================================================
'       Chevron Handling!
' ==================================================

Private Sub ReBar_ChevronPushed(ByVal Band As ReBarBand, ByVal AbsReBarLeft As Long, ByVal AbsReBarTop As Long, ByVal ChevronLeft As Long, ByVal ChevronTop As Long, ByVal ChevronWidth As Long, ByVal ChevronHeight As Long, ByVal FirstInvisibleButton As Long, ByVal EventFromUser As Boolean)
  If FirstInvisibleButton Then
    ChevronLeft = AbsReBarLeft + ChevronLeft
    ChevronTop = AbsReBarTop + ChevronTop
    Select Case Band.Key
      Case "MENUBAR": Call MenuBar.HandleChevron(ChevronLeft, ChevronTop, ChevronWidth, ChevronHeight, FirstInvisibleButton, Band.Background)
      Case "TOOLBAR": Call ToolBar.HandleChevron(Me.MenuBar.hWnd, ChevronLeft, ChevronTop, ChevronWidth, ChevronHeight, FirstInvisibleButton, Band.Background)
    End Select
    If Err.Number Then ListLog Err.Description
  End If
End Sub


'------------------------------------------------------------------
' Toolbar Events

Private Sub MenuBar_MenuItemClick(ByVal MenuItem As PopupMenus.MenuItem, ByVal Source As CoolBars.MbrActionSource)
  ListLog "MenuItemClick: " & MenuItem.Caption
End Sub

Private Sub ToolBar_CustomizeInitialize(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_CustomizeInitialize: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_CustomizeTerminate(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_CustomizeTerminate: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ButtonClick(Button As ToolBarButton)
  If Button.Key = "PREVIEW" Then Button.Checked = Not Button.Checked
  ListLog "ToolBar_ButtonClick: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ButtonDeleting(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_ButtonDeleting: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ButtonDragInitialize(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_ButtonDragInitialize: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ButtonDragOut(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_ButtonDragOut: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ButtonDragTerminate(ByVal Button As CoolBars.ToolBarButton)
  ListLog "ToolBar_ButtonDragTerminate: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_CustomizeChange()
  ListLog "ToolBar_CustomizeChange"
End Sub

Private Sub ToolBar_Click(ByVal Button As CoolBars.TbrButtonIndex)
  ListLog "ToolBar_Click: " & Button
End Sub

Private Sub ToolBar_CustomizeQueryDelete(ByVal Button As CoolBars.ToolBarButton, Allow As Boolean)
  ListLog "ToolBar_CustomizeQueryDelete: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_CustomizeHelp()
  ListLog "ToolBar_CustomizeHelp"
End Sub

Private Sub ToolBar_CustomizeShowDlg(ShowHelp As Boolean)
  ListLog "ToolBar_CustomizeShowDlg"
End Sub

Private Sub ToolBar_CustomizeQueryInsert(ByVal Button As CoolBars.ToolBarButton, ByVal NewButtonIndex As Long, Allow As Boolean)
  ListLog "ToolBar_CustomizeQueryInsert: " & DebugCaption(Button) & " " & NewButtonIndex
End Sub

Private Sub ToolBar_CustomizeReset()
  ListLog "ToolBar_CustomizeReset"
End Sub

Private Sub ToolBar_DblClick(ByVal Button As CoolBars.TbrButtonIndex)
  ListLog "ToolBar_DblClick: " & Button
End Sub

Private Sub ToolBar_ButtonDropDown(ByVal Button As CoolBars.ToolBarButton, ByVal DropX As Long, ByVal DropY As Long, ReturnMessage As CoolBars.TbrDropDownState)
  ListLog "ToolBar_ButtonDropDown: " & Button
End Sub

Private Sub ToolBar_HitEnter()
  ListLog "ToolBar_HitEnter"
End Sub

Private Sub ToolBar_HotItemChange(ByVal OldButton As CoolBars.ToolBarButton, ByVal NewButton As CoolBars.ToolBarButton, ByVal Flags As CoolBars.TbrHotItemChangeFlags, Allow As Boolean)
'  ListLog"ToolBar_HotItemChange"
End Sub

Private Sub ToolBar_MouseMove()
  ListLog "ToolBar_MouseMove"
End Sub

Private Sub ToolBar_NeedButtonInfo(ByVal Button As CoolBars.ToolBarButton, ByVal Requested As CoolBars.TbrRequestType, Text As String, ImageIndex As Long, KeepAsking As Boolean)
  ListLog "ToolBar_NeedButtonInfo: " & DebugCaption(Button)
End Sub

Private Sub ToolBar_ReleaseCapture()
  ListLog "ToolBar_ReleaseCapture"
End Sub

Private Sub ToolBar_RestoreSettings()
  ListLog "ToolBar_RestoreSettings"
End Sub

Private Sub ToolBar_SaveSettings()
  ListLog "ToolBar_SaveSettings"
End Sub

Private Sub ToolBar_ShowToolTip(ByVal Button As CoolBars.ToolBarButton, Text As String)
  ListLog "ToolBar_ShowToolTip"
  Text = Button.Caption
End Sub

Private Sub ToolBar_ToolBarGotFocus()
  ListLog "ToolBar_ToolBarGotFocus"
End Sub

Private Sub ToolBar_ToolBarLostFocus()
  ListLog "ToolBar_ToolBarLostFocus"
End Sub

Private Sub ToolBar_ToolTipsCreated(ByVal hWndToolTip As Long)
  ListLog "ToolBar_ToolTipsCreated"
End Sub

Private Function DebugCaption(ByVal Button As Object) As String
  If Not Button Is Nothing Then
    On Error Resume Next
      DebugCaption = Button.Caption
      If Err.Number Then DebugCaption = "<" & Err.Description & ">"
    On Error GoTo 0
    DebugCaption = DebugCaption & ", " & Button.Key
  Else
    DebugCaption = "<NOTHING>"
  End If
End Function


'------------------------------------------------------------------
' Log events

Private Sub ListLog(Text As String)
  lstInfo.AddItem Text, 0
  If lstInfo.ListCount > 100 Then
    lstInfo.RemoveItem lstInfo.ListCount - 1
  End If
End Sub



'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub


